function [Hp,Qp,surgeheight] = Surge_Chamber3(Q,H,Qp,Hp,surgepos,B2,B3,R2,R3,dt,surgeheight,k)

global C
global Vgas
global z
mode = 'enable';
%Chamber dimensions
SurgeD = 10;
SurgeH = 10;
SurgeL = 77.5;
%Chamber polytropic exponent
n = 1.2;
Vsurge = SurgeD*SurgeH*SurgeL;
Vgas0 = 4681;                           %Initial gas volume
Vfluid = Vsurge - Vgas0;                %Volume of fluid
z0 = Vfluid/(SurgeL*SurgeD);            %Starting water level

if isempty(C)
    Hjunction0 = H(surgepos);
    C = (Hjunction0 - z0)*(Vgas0)^n;    %Calculation of chamber constant
    Vgas = Vgas0;
    z = z0;
end

if strcmp(mode,'enable')
    Cp = H(surgepos-2) + Q(surgepos-2)*(B2 - R2*abs(Q(surgepos-2)));    %Eq 3.20
    %OBS OBS OBS MULIG DET SKAL ST Q(SURGEPOS) DER
    Cm = H(surgepos+1) - Q(surgepos+1)*(B3 - R3*abs(Q(surgepos+1)));    %Eq 3.21

    Q1 = Q(surgepos - 1);
    %OBS OBS OBS MULIG DET SKAL ST Q(SURGEPOS) DER
    Q2 = Q(surgepos + 1);

    syms Hjunction
    syms Hchamber
    syms Qp1
    syms Qp2
    syms Qp3
    syms zint
    
%     Hjunction = Hjunction0;
%     Hchamber = Hjunction - z0;
%     Qp1 = 33.4;
%     Qp2 = Qp1;
%     Qp3 = 0;
%     zint = z0;
    

    EQ1 = Hchamber*(Vgas - 0.5*dt*(Qp3 + (Q1 - Q2)))^n - C;
    EQ2 = Cp - B2*Qp1 - Hjunction;
    EQ3 = Cm + B3*Qp2 - Hjunction;
    EQ4 = Hjunction - zint - Hchamber;
    EQ5 = Qp3 + Qp2 - Qp1;
    EQ6 = SurgeH - ((Vgas - 0.5*dt*(Qp3 + (Q1 - Q2)))/(SurgeD*SurgeL)) - zint;
    
    nsolution = newton_n_dim(0.0001,[H(surgepos), H(surgepos)+z,Q1,Q2,Q1-Q2,z],[Hjunction,Hchamber,Qp1,Qp2,Qp3,zint],[EQ1;EQ2;EQ3;EQ4;EQ5;EQ6]);
    nsolution = double(nsolution);
    Hp(surgepos) = nsolution(1);% - 0.0043;
    Qp(surgepos) = nsolution(4);% - 0.001;
    chamberflow = nsolution(5);

    Vgas = Vgas - 0.5*dt*(chamberflow + (Q1 - Q2));
    surgeheight(k) = SurgeH - (Vgas/(SurgeD*SurgeL));            %Recomputes waterlevel
    z = surgeheight(k);

elseif strcmp(mode,'disable')
    Cp = H(surgepos-1) + Q(surgepos-1)*(B - R*abs(Q(surgepos-1)));    %Eq 3.20
	Cm = H(surgepos+1) - Q(surgepos+1)*(B - R*abs(Q(surgepos+1)));    %Eq 3.21
	Hpipe = 0.5*(Cp+Cm);                         %Eq 3.22
	Qout = (Cp-Hpipe)/B;  
    Qin = NaN;
    Vgas = NaN;
    z = NaN;
else
    
    
end
end