function [] = drivaGUI()
%% BESKRIVELSE
% drivaGUI er en funksjon skrevet av Even Lillefosse Haugen, som en del av
% sin masteravhandling ved Vannkraftlaboratoriet NTNU vren 2013.
% AVHENGIGHET
%DrivaSIM
%SurgeChamber
%AggregateMOC
%newton_n_dim
%objectfinder
% INNDATA
%Brukergrensesnittet mottar ikke inndata
% UTDATA
%Brukergrensesnittet returnerer ikke utdata.
% STRUKTUR
% Programstrukturen er lagt opp slik at gui'et er i strst mulig grad samlet i ett skript med nstede funksjoner. Den grafiske delen av GUI'et opprettes i
% begynnelsen av programmet, samt deklarasjonen av samtlige callbacks til alle element i grensesnittet. Callbackimplementasjonene ligger
% etter initialiseringen av grafikk og callbackdeklarasjon, og tar ikke imot inputargument og bruker den globale structen S samt objektsk. 
% Helt tilsslutt implementeres hjelpefunskjonen som vanlige funskjoner, og mottar input, og bruker ikke globale variable.
% GUI HIERARKI
%Structen som tar vare p elementene i gui'et er S. S inneholder samtlige elementer unntatt elementene som er underlagt buttongroup'ene, dvs
%tabs'ene. Alle element som er underlagt en tab er subklasser eller "children" av tab-superklassen som er medlem av structen S. Fra S kan
%man dermed flge suksessjonen helt ned til alle element i gui'et. Det blir
%imidlertid brukt objektsk der det er mulig for  holde koden ryddig.
%Dette gjres ved hjelp av funksjonen objectfinder()
% LAGRING AV DATA (DISK)
% Data lagres ikke

close all
clear all
clc
global S;
global results;

%% OPPRETTER HOVEDGUI
% Starter p laveste niv og oppretter gui lagvis
SCR = get(0,'Screensize');                                              %henter skjermstrrelse som referansepunkt
S.base = figure('numbertitle','off',...                                 %Lager figur som er laveste niv av gui.vis/ikke vis figurnr av totale spawnede figurer
                'menubar','none',...                                    %Valg av menybar
                'Toolbar','none',...
                'units','pixels',...                                    %Enheter for skjermplassering, pixels er antall skjermpunkt
                'position',[SCR(3)/2-600 ,SCR(4)/2-350 , 1200, 800],... %startposisjon x,startposisjon y,bredde,hyde
                'name','DrivaSIM',...                                   %gui-navn
                'resize','on');                                         %bestemmer om brukeren skal kunne resize gui         
            
S.logo = axes('units','normalized',...                                  %oppretter vindu for plotting av logo
              'position',[940/1200 5/800 240/1200 50/800]);             %setter posisjon
          logoimg = imread('logo.png');                                 %leser inn logo fra dir
          imagesc(logoimg);                                             %skriver logo til skjerm
          axis off;                                                     %skrur av labels
          
            
% Oppretter vindu for visning av prisgraf
 S.hentax = axes('visible','on',...                                     %bestemmer synlig, default er on
                 'units','normalized',...                               %Enhet satt til normalized for reskalering
                 'fontSize',12,...                                      %setter skriftstrrelse
                 'tag','mainaxis',...
                 'position',[60/1200 80/800 1100/1200 400/800]);         %Setter posisjon i prosentml av frste lag i GUI (se over)
                          
                           
 S.statust = uicontrol('style','listbox',...                            %Oppretter statusvindu for display av oppsumeringsinfo
                       'units','normalized',...
                       'position',[670/1200 725/800 500/1200 70/800],...
                       'backgroundcolor','g',...
                       'FontSize',10,...
                       'tag','statusw',...
                       'HorizontalAlignment','left');                   %srger for rett formatering av tekstposisjon               
                   
simstatus_bg = uibuttongroup('backgroundcolor','red',...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'visible','on',...                              %Dette er default valgt tab ved oppstart. Settes derfor til visible
                        'position',[5/1200 5/800 88/1200 28/800]);                 
                   
simstatus = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'backgroundcolor','red',...
                       'units','normalize',...
                       'position',[7/1200 6/800 84/1200 25/800],...
                       'HorizontalAlignment','left',...
                       'tag','simstatus',...
                       'fontSize',12,...
                       'string','Not running'); %#ok<NASGU>                   
                   
percentage_bg = uibuttongroup('backgroundcolor','red',...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'visible','on',...                              %Dette er default valgt tab ved oppstart. Settes derfor til visible
                        'position',[95/1200 5/800 50/1200 28/800]);                    
                   
simstatus_percentage = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'backgroundcolor','red',...
                       'units','normalize',...
                       'position',[97/1200 6/800 46/1200 25/800],...
                       'HorizontalAlignment','left',...
                       'tag','simstatus_percentage',...
                       'fontSize',12,...
                       'string','');         
                                
% Plasserer tabs (dette er juks siden matlab ikke sttter tabs, men vi modder en jallalsning)
 
relxpos = 5;                                                                         %Setter startposisjon for tabs i pixler (x)
relypos = 755;                                                                       %setter startposisjon for tabs i pixler (y)
tabheight = 40;                                                                      %Hyden p tab
tablength = 80;                                                                      %lengden p tabs
tabnames = {'Simulation' 'Conduits' 'Turbine' 'Generator' 'Events' 'Results' 'Settings'};   %Angir hvor mange tabs som skal lages samt deres navn

%Plasserer default tab (m ha minst 1)
S.tg(1) = uicontrol('style','toggle',...                                             %frste togglebar
                    'units','normalized',...
                    'position',[5/1200 755/800 80/1200 40/800],...
                    'string',tabnames(1),...                                              %navn p togglebar
                    'val',1);                                                        %Setter knappen til "trykket inn" ved oppstart
%Plasser ytterligere brukerdefinerte tabs bestemt av variablene over
for i = 2:length(tabnames)
    S.tg(i) = uicontrol('style','toggle',...
    'units','normalized',...
    'position',[(relxpos + (i-1)*tablength)/1200 relypos/800 tablength/1200 tabheight/800],...
    'string',tabnames{i},...
    'value',1,...                                                                   %Setter knappen til "ikke trykket inn" ved oppstart
    'enable','on');                                                                %Skrur av funksjonen p de andre knappene til de trengs
end

%% BYGGER SIMULATION TAB
S.sim_bg = uibuttongroup('title','Simulation properties',...        %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'visible','on',...                              %Dette er default valgt tab ved oppstart. Settes derfor til visible
                        'position',[30/1200 525/800 950/1200 200/800]);
                    

sim_time_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.sim_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 165/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Simulation time:'); %#ok<NASGU>
                   
sim_dt_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.sim_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 135/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Time increment:'); %#ok<NASGU>
                   
sim_winterv_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.sim_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 105/200 129/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Data write interval:'); %#ok<NASGU>

                  
sim_time = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.sim_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 170/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','sim_tmax',...
                        'string','15',...
                        'fontsize',9);
                          
str = '1|0.1|0.01';
sim_dt = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',... 
                               'parent',S.sim_bg,...                                %setter superklasse til innstillinger'taben for hndtering av synlighet
                               'position',[140/950 140/200 120/950 25/200],...
                               'string',str,...                                      %setter string laget over som visningsvariabel
                               'value',2,...                                         %setter default dato til dagens
                               'tag','sim_dt',...
                               'fontsize',9);
                            
sim_winterv = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...                    
                        'parent',S.sim_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 110/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','sim_writeinterval',...
                        'string','1',...
                        'fontsize',9);
                    
sim_run_cmd = uicontrol('style','pushbutton',...                              %plasserer piltast for foroverrulling
                            'units','normalized',...
                            'position',[750/950 8/200 190/950 50/200],...
                            'string','Run',...
                            'fontsize',12,...
                            'parent',S.sim_bg,...                               %Setter parent til ukepanel for  opprettholde ryddig hierarki.
                            'tag','run');                                  %Setter elementet til inaktivt ettersom den er ubrukelig uten data                    
                           
%% BYGGER CONDUITS-TAB
S.conduits_bg = uibuttongroup('title','Conduit properties',...                   %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                         'backgroundcolor',[0.8 0.8 0.82],...
                         'fontsize',11,...
                         'units','normalized',...
                         'borderType','etchedout',...
                         'visible','off',...                              %Denne tab'en er ikke valgt ved oppstart, settes derfor til usynlig ved creation
                         'position',[30/1200 525/800 950/1200 200/800]);

cond_reservoir_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.conduits_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 165/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Reservoir head:');  
                   
cond_wavespeed_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.conduits_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 135/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Wavespeed:');                    
                   
cond_frictionf_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.conduits_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 105/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Friction factor:'); %#ok<NASGU>                   
                  
cond_reservoir = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.conduits_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 170/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','cond_reservoir',...
                        'string','653.3',...
                        'fontsize',9);                   
                   
cond_wavespeed = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.conduits_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 140/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','cond_wavespeed',...
                        'string','1200',...
                        'fontsize',9);
                    
cond_frictionf = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.conduits_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 110/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','cond_friction',...
                        'string','0.04671',...
                        'fontsize',9);                    
                    
%% BYGGER TURBINE-TAB
S.turbine_bg = uibuttongroup('title','Turbine properties',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'visible','off',...                                     %Denne tab'en er ikke valgt ved oppstart, settes derfor til invisible
                        'position',[30/1200 525/800 950/1200 200/800]);
                    
turb1_bg =   uibuttongroup('title','Turbine 1',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.turbine_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[5/950 10/200 300/950 190/200]);
                    
turb2_bg =   uibuttongroup('title','Turbine 2',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.turbine_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[325/950 10/200 300/950 190/200]);                      
                    
turbine1_Rm_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 150/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Runner loss:');
                   
turbine2_Rm_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[332/950 150/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Runner loss:');
                   
turbine1_Tk1_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 120/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Transient sd:');
                   
turbine1_Tk2_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 90/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Permanent sd:');
                   
turbine1_Tk3_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 60/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Integration time:');

turbine1_Hr_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 30/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Rated head:');
                   
turbine2_Tk1_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[332/950 120/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Transient sd:');
                   
turbine2_Tk2_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[332/950 90/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Permanent sd:');
                   
turbine2_Tk3_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[332/950 60/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Integration time');
                   
turbine2_Hr_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.turbine_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[332/950 30/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Rated head:');
                   
                   
turbine1_deltat = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 120/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine1_deltat',...
                        'string','0.6',...
                        'fontsize',9);
                    
turbine1_deltab = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 90/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine1_deltab',...
                        'string','-0.05',...
                        'fontsize',9);
                    
turbine1_Ti = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 60/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine1_Ti',...
                        'string','8',...
                        'fontsize',9);
                    
turbine1_Hr = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 30/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine1_Hr',...
                        'string','540',...
                        'fontsize',9);
                    
turbine2_deltat = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[455/950 120/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine2_deltat',...
                        'string','0.5',...
                        'fontsize',9);
                    
turbine2_deltab = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[455/950 90/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine2_deltab',...
                        'string','-0.05',...
                        'fontsize',9);
                    
turbine2_Ti = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[455/950 60/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine2_Ti',...
                        'string','8',...
                        'fontsize',9);
                    
turbine2_Hr = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[455/950 30/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine2_Hr',...
                        'string','540',...
                        'fontsize',9);
                   
turbine1_Rm = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 150/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine1_Rm',...
                        'string','0.04',...
                        'fontsize',9);
                    
turbine2_Rm = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.turbine_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[455/950 150/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','turbine2_Rm',...
                        'string','0.042',...
                        'fontsize',9);                     
     
%% BYGGER GENERATOR-TAB
S.generator_bg = uibuttongroup('title','Generator properties',...                 %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'visible','off',...                                     %Denne tab'en er ikke valgt ved oppstart, settes derfor til invisible
                        'position',[30/1200 525/800 950/1200 200/800]);
                    
gen1_bg =   uibuttongroup('title','Generator 1',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.generator_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[5/950 10/200 300/950 190/200]);
                    
gen2_bg =   uibuttongroup('title','Generator 2',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.generator_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[325/950 10/200 300/950 190/200]);                     
                    
generator1_Pref_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 150/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Output Power:');  
                   
generator1_delta_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 120/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Ref delta:');
                   
generator1_Eref_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 90/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Rated voltage:');
                   
generator1_deltat_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 60/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Transient sd:');
                   
generator1_deltab_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 30/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Permanent sd:');
                   
generator1_Ti_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[10/950 0/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Integration time');                   
                   
generator1_Pref = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 155/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator1_Pref',...
                        'string','64.193',...
                        'fontsize',9);                   
                   
generator1_delta = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 125/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator1_deltaref',...
                        'string','pi',...
                        'fontsize',9); 
                    
generator1_Eref = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 95/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator1_Eref',...
                        'string','11000',...
                        'fontsize',9);
                    
generator1_deltat = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 65/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator1_deltatg',...
                        'string','0.6',...
                        'fontsize',9);
                    
generator1_deltab = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 35/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator1_deltabg',...
                        'string','-0.05',...
                        'fontsize',9);
                    
generator1_Ti = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[140/950 5/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator1_Ti',...
                        'string','6',...
                        'fontsize',9);                                       
                    
generator2_Pref_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[330/950 150/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Output Power:');  
                   
generator2_delta_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[330/950 120/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Ref delta:');
                   
generator2_Eref_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[330/950 90/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Rated voltage:');
                   
generator2_deltat_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[330/950 60/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Transient sd:');
                   
generator2_deltab_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[330/950 30/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Permanent sd:');
                   
generator2_Ti_desc = uicontrol('style','text',...                         %plasserer beskrivende tekst
                       'parent',S.generator_bg,...                           %setter superklasse til innstillinger'taben for hndtering av synlighet
                       'backgroundcolor',[0.8 0.8 0.82],...
                       'units','normalize',...
                       'position',[330/950 0/200 125/950 25/200],...
                       'HorizontalAlignment','left',...
                       'fontSize',12,...
                       'string','Integration time');                     
                   
generator2_Pref = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[460/950 155/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator2_Pref',...
                        'string','68.249',...
                        'fontsize',9);                   
                   
generator2_delta = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[460/950 125/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator2_deltaref',...
                        'string','pi',...
                        'fontsize',9); 
                    
generator2_Eref = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[460/950 95/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator2_Eref',...
                        'string','11000',...
                        'fontsize',9); 
                    
generator2_deltat = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[460/950 65/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator2_deltatg',...
                        'string','0.6',...
                        'fontsize',9);
                    
generator2_deltab = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[460/950 35/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator2_deltabg',...
                        'string','-0.05',...
                        'fontsize',9);
                    
generator2_Ti = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.generator_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[460/950 5/200 120/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','generator2_Ti',...
                        'string','6',...
                        'fontsize',9);                    

%% BYGGER EVENTS-TAB
S.events_bg = uibuttongroup('title','Event settings',...                %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                          'backgroundcolor',[0.8 0.8 0.82],...
                          'fontsize',11,...
                          'units','normalized',...
                          'borderType','etchedout',...
                          'visible','off',...                                    %Denne tab'en er ikke valgt ved oppstart, settes derfor til invisible
                          'position',[30/1200 525/800 950/1200 200/800]);
                      
events_turb1_bg =   uibuttongroup('title','Turbine 1',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.events_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[5/950 10/200 300/950 190/200]);
                    
events_turb2_bg =   uibuttongroup('title','Turbine 2',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.events_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[325/950 10/200 300/950 190/200]);
                    
events_grid_bg =   uibuttongroup('title','Grid',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                        'parent',S.events_bg,...
                        'backgroundcolor',[0.8 0.8 0.82],...
                        'fontsize',11,...
                        'units','normalized',...
                        'borderType','etchedout',...
                        'position',[645/950 10/200 300/950 190/200]);                    
                    
events_turb1_t1 = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.events_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[10/950 150/200 50/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','events1_t1',...
                        'string','1',...
                        'fontsize',9);
                    
events_turb1_t2 = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.events_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[10/950 120/200 50/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','events1_t2',...
                        'string','11',...
                        'fontsize',9);
                    
events_turb1_t3 = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.events_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[10/950 90/200 50/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','events1_t3',...
                        'string','20',...
                        'fontsize',9);                    

events_turb2_t1 = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.events_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[335/950 150/200 50/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','events2_t1',...
                        'string','1',...
                        'fontsize',9);
                    
events_turb2_t2 = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.events_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[335/950 120/200 50/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','events2_t2',...
                        'string','11',...
                        'fontsize',9);
                    
events_turb2_t3 = uicontrol('style','edit',...                              %Plasserer inputboks for  ta inn data fra bruker
                        'units','normalized',...
                        'parent',S.events_bg,...                          %setter superklasse til innstillinger'taben for hndtering av synlighet
                        'position',[335/950 90/200 50/950 25/200],...
                        'HorizontalAlignment','left',...
                        'tag','events2_t3',...
                        'string','20',...
                        'fontsize',9);                   
                      
typestr = 'Rejection|Regulation';
events_turb11 = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',...
                               'parent',S.events_bg,...
                               'position',[80/950 150/200 120/950 25/200],...
                               'string',typestr,...
                               'value',2,...
                               'tag','eventtype11',...
                               'fontsize',9);
                           
events_turb12 = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',...
                               'parent',S.events_bg,...
                               'position',[80/950 120/200 120/950 25/200],...
                               'string',typestr,...
                               'value',2,...
                               'tag','eventtype12',...
                               'fontsize',9);
                           
events_turb13 = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',...
                               'parent',S.events_bg,...
                               'position',[80/950 90/200 120/950 25/200],...
                               'string',typestr,...
                               'value',2,...
                               'tag','eventtype13',...
                               'fontsize',9);                           
                           
events_turb21 = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',... 
                               'parent',S.events_bg,...                                %setter superklasse til innstillinger'taben for hndtering av synlighet
                               'position',[405/950 150/200 120/950 25/200],...
                               'string',typestr,...                                      %setter string laget over som visningsvariabel
                               'value',2,...                                         %setter default dato til dagens
                               'tag','eventtype21',...
                               'fontsize',9);
                           
events_turb22 = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',... 
                               'parent',S.events_bg,...                                %setter superklasse til innstillinger'taben for hndtering av synlighet
                               'position',[405/950 120/200 120/950 25/200],...
                               'string',typestr,...                                      %setter string laget over som visningsvariabel
                               'value',2,...                                         %setter default dato til dagens
                               'tag','eventtype22',...
                               'fontsize',9);
                           
events_turb23 = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',... 
                               'parent',S.events_bg,...                                %setter superklasse til innstillinger'taben for hndtering av synlighet
                               'position',[405/950 90/200 120/950 25/200],...
                               'string',typestr,...                                      %setter string laget over som visningsvariabel
                               'value',2,...                                         %setter default dato til dagens
                               'tag','eventtype23',...
                               'fontsize',9);                           
                                    
%% BYGGER RESULTS-TAB
S.results_bg = uibuttongroup('title','Results',...                   %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                          'backgroundcolor',[0.8 0.8 0.82],...
                          'fontsize',11,...
                          'units','normalized',...
                          'borderType','etchedout',...
                          'visible','off',...                                   %Denne tab'en er ikke valgt ved oppstart, settes derfor til invisible
                          'position',[30/1200 525/800 950/1200 200/800]);
                      
typestr = 'Pressure Turbine|Flow Turbine|Pressure Surge Chamber|Flow Surge Chamber|Surge level|Turbine Rotation Speed|Kappa|Generator Magnetics|Generator Angle|Generator Voltage|Generator Current|Power|Turbine all|Stability|Efficiency|Pressure Transient';
results_plottype = uicontrol('style','popup',...                                  %Plasserer inputboks for  ta inn data fra bruker
                               'units','normalized',... 
                               'parent',S.results_bg,...                                %setter superklasse til innstillinger'taben for hndtering av synlighet
                               'position',[40/950 120/200 120/950 25/200],...
                               'string',typestr,...                                      %setter string laget over som visningsvariabel
                               'value',1,...                                         %setter default dato til dagens
                               'tag','plottype',...
                               'fontsize',9);                       
                                   
results_GUIplott = uicontrol('style','pushbutton',...                               
                            'units','normalized',...
                            'position',[760/950 10/200 170/950 40/200],...
                            'string','Plott in GUI',...
                            'fontsize',12,...
                            'parent',S.results_bg);
                        
results_extplott = uicontrol('style','pushbutton',...                               
                            'units','normalized',...
                            'position',[760/950 60/200 170/950 40/200],...
                            'string','Plott in external window',...
                            'fontsize',12,...
                            'parent',S.results_bg);
                      
%% BYGGER INNSTILLINGER TAB
S.settings_bg = uibuttongroup('title','General settings',...                          %Plasserer en buttongroup for lett  skjule alle valg ved tab-skifte
                          'backgroundcolor',[0.8 0.8 0.82],...
                          'fontsize',11,...
                          'units','normalized',...
                          'borderType','etchedout',...
                          'visible','off',...                                   %Denne tab'en er ikke valgt ved oppstart, settes derfor til invisible
                          'position',[30/1200 525/800 950/1200 200/800]);
                                                                       
%% INITIALIZATION
    statusoppd('Oppstart') 
                                       
%% LAGER TAB-FUNKSJONALITET
set(S.tg(:),{'callback'},{{@tg_call,S}})                                                            %Setter samme callback for alle tabs (de skal toggle funksjonalitet)

function [] = tg_call(varargin)
% Callback for menyknappene.
[h,S] = varargin{[1,3]};                                                                            %Henter handle-struct

if get(h,'val')==0                                                                                  %Her er en knapp allerede trykket inn
    set(h,'val',1)                                                                                  %For  opprettholde tab-liknende funksjonalitet
end

switch h
    case S.tg(1)%HENT                                                                               %dersom knapp trykkes inn
        %set(S.tg([2,3,4,5,6,7]),'val',0)                                                            %setter alle andre knapper til "ikke trykket p"
        set([S.conduits_bg,S.turbine_bg,S.generator_bg,S.events_bg,S.results_bg,S.settings_bg],{'visible'},{'off'})    %setter alle andre panel til usynlig
        set([S.sim_bg],{'visible'},{'on'})                                                         %setter aktuelle panel til synlig
        set(S.tg(1),'Value',0)
        set([S.tg(2),S.tg(3),S.tg(4),S.tg(5),S.tg(6),S.tg(7)],{'value'},{1})
        
    case S.tg(2)%DGNPROFIL
        %set(S.tg([1,3,4,5,6,7]),{'val'},{0})
        set([S.sim_bg,S.turbine_bg,S.generator_bg,S.events_bg,S.results_bg,S.settings_bg],{'visible'},{'off'})
        set([S.conduits_bg],{'visible'},{'on'})
        set(S.tg(2),'Value',0)
        set([S.tg(1),S.tg(3),S.tg(4),S.tg(5),S.tg(6),S.tg(7)],{'value'},{1})

    case S.tg(3)%UKEPROFIL
        %set(S.tg([1,2,4,5,6,7]),{'val'},{0})
        set([S.sim_bg,S.conduits_bg,S.generator_bg,S.events_bg,S.results_bg,S.settings_bg],{'visible'},{'off'})
        set([S.turbine_bg],{'visible'},{'on'})
        set(S.tg(3),'Value',0)
        set([S.tg(1),S.tg(2),S.tg(4),S.tg(5),S.tg(6),S.tg(7)],{'value'},{1})

    case S.tg(4) %MIN
        %set(S.tg([1,2,3,5,6,7]),{'val'},{0})
        set([S.sim_bg,S.conduits_bg,S.turbine_bg,S.events_bg,S.results_bg,S.settings_bg],{'visible'},{'off'})
        set([S.generator_bg],{'visible'},{'on'})   
        set(S.tg(4),'Value',0)
        set([S.tg(1),S.tg(2),S.tg(3),S.tg(5),S.tg(6),S.tg(7)],{'value'},{1})

    case S.tg(5)%MAKS
        %set(S.tg([1,2,3,4,6,7]),{'val'},{0})
        set([S.sim_bg,S.conduits_bg,S.turbine_bg,S.generator_bg,S.results_bg,S.settings_bg],{'visible'},{'off'})
        set([S.events_bg],{'visible'},{'on'}) 
        set(S.tg(5),'Value',0)
        set([S.tg(1),S.tg(2),S.tg(3),S.tg(4),S.tg(6),S.tg(7)],{'value'},{1})

    case S.tg(6)%SCENARIO
        %set(S.tg([1,2,3,4,5,7]),{'val'},{0})
        set([S.sim_bg,S.conduits_bg,S.turbine_bg,S.generator_bg,S.events_bg,S.settings_bg],{'visible'},{'off'})
        set([S.results_bg],{'visible'},{'on'}) 
        set(S.tg(6),'Value',0)
        set([S.tg(1),S.tg(2),S.tg(3),S.tg(4),S.tg(5),S.tg(7)],{'value'},{1})

    case S.tg(7)%INNSTILLINGER
        %set(S.tg([1,2,3,4,6]),{'val'},{0})
        set([S.sim_bg,S.conduits_bg,S.turbine_bg,S.generator_bg,S.events_bg,S.results_bg],{'visible'},{'off'})
        set([S.settings_bg],{'visible'},{'on'})
        set(S.tg(7),'Value',0)
        set([S.tg(1),S.tg(2),S.tg(3),S.tg(4),S.tg(5),S.tg(6)],{'value'},{1})
end 
end

%% DEKLARERER CALLBACKS
% DEKLARERER CALLBACKS FOR YTTERSTE LAG AV GUI. IMPLEMENTERES NEDERST
set(S.base,'CloseRequestFcn',@lukk);                                    %Deklarer funksjon som eksekveres ved lukking av gui'et
% DEKLARERER CALLBACKS FOR SIMULATION TAB
set(sim_run_cmd,'callback',@runsimulation);

% DEKLARERER CALLBACKS FOR CONDUITS TAB

% DEKLARERER CALLBACKS FOR TURBINE TAB

% DEKLARERER CALLBACKS FOR GENERATOR TAB

% DEKLARERER CALLBACKS FOR EVENTS TAB

% DEKLARERER CALLBACKS FOR RESULTS TAB
set(results_GUIplott,'callback',@GUIplott);
set(results_extplott,'callback',@externalplott);

% DEKLARERER CALLBACKS FOR SETTINGS TAB

%% IMPLEMENTASJON AV KJRERUTINE FOR SIMULERING
function runsimulation(varargin)
%collecting simulation parameters from GUI
tmax = str2num(get(objectfinder('sim_tmax'),'string'));
dt = get(objectfinder('sim_dt'),'string');
dt = str2num(dt(get(objectfinder('sim_dt'),'value'),:));
writeint = str2num(get(objectfinder('sim_writeinterval'),'string'));

%collecting conduit parameters from GUI
Hr = str2num(get(objectfinder('cond_reservoir'),'string'));
wavespeed = str2num(get(objectfinder('cond_wavespeed'),'string'));
frictionfactor = str2num(get(objectfinder('cond_friction'),'string'));

%collecting turbine parameters from GUI
Rm1 = str2num(get(objectfinder('turbine1_Rm'),'string'));
Rm2 = str2num(get(objectfinder('turbine2_Rm'),'string'));
deltat1 = str2num(get(objectfinder('turbine1_deltat'),'string'));
deltab1 = str2num(get(objectfinder('turbine1_deltab'),'string'));
deltat2 = str2num(get(objectfinder('turbine2_deltat'),'string'));
deltab2 = str2num(get(objectfinder('turbine2_deltab'),'string'));
Ti1 = str2num(get(objectfinder('turbine1_Ti'),'string'));
Ti2 = str2num(get(objectfinder('turbine2_Ti'),'string'));
deltatg1 = str2num(get(objectfinder('generator1_deltatg'),'string'));
deltatg2 = str2num(get(objectfinder('generator2_deltatg'),'string'));
deltabg1 = str2num(get(objectfinder('generator1_deltabg'),'string'));
deltabg2 = str2num(get(objectfinder('generator2_deltabg'),'string'));
genTi1 = str2num(get(objectfinder('generator1_Ti'),'string'));
genTi2 = str2num(get(objectfinder('generator2_Ti'),'string'));
%collecting generator parameters from GUI
Pref1 = str2num(get(objectfinder('generator1_Pref'),'string'));
deltaref1 = str2num(get(objectfinder('generator1_deltaref'),'string'));
Eref1 = str2num(get(objectfinder('generator1_Eref'),'string'));
Pref2 = str2num(get(objectfinder('generator2_Pref'),'string'));
deltaref2 = str2num(get(objectfinder('generator2_deltaref'),'string'));
Eref2 = str2num(get(objectfinder('generator2_Eref'),'string'));
Hr1 = str2num(get(objectfinder('turbine1_Hr'),'string'));
Hr2 = str2num(get(objectfinder('turbine2_Hr'),'string'));

%collecting simulation scheme from GUI
t1_1 = str2num(get(objectfinder('events1_t1'),'string'));
t1_2 = str2num(get(objectfinder('events1_t2'),'string'));
t1_3 = str2num(get(objectfinder('events1_t3'),'string'));
mode1_1 = get(objectfinder('eventtype11'),'string');
mode1_1 = strtrim(mode1_1(get(objectfinder('eventtype11'),'value'),:));
mode1_2 = get(objectfinder('eventtype12'),'string');
mode1_2 = strtrim(mode1_2(get(objectfinder('eventtype12'),'value'),:));
mode1_3 = get(objectfinder('eventtype13'),'string');
mode1_3 = strtrim(mode1_3(get(objectfinder('eventtype13'),'value'),:));


t2_1 = str2num(get(objectfinder('events2_t1'),'string'));
t2_2 = str2num(get(objectfinder('events2_t2'),'string'));
t2_3 = str2num(get(objectfinder('events2_t3'),'string'));
mode2_1 = get(objectfinder('eventtype11'),'string');
mode2_1 = strtrim(mode2_1(get(objectfinder('eventtype21'),'value'),:));
mode2_2 = get(objectfinder('eventtype12'),'string');
mode2_2 = strtrim(mode2_2(get(objectfinder('eventtype22'),'value'),:));
mode2_3 = get(objectfinder('eventtype13'),'string');
mode2_3 = strtrim(mode2_3(get(objectfinder('eventtype23'),'value'),:));

%putting simulation parameters into data carrier(struct)
carrier.tmax = tmax;
carrier.dt = dt;
carrier.writeint = writeint;

carrier.Hr = Hr;
carrier.wavespeed = wavespeed;
carrier.frictionfactor = frictionfactor;

carrier.Rm1 = Rm1;
carrier.Rm2 = Rm2;
carrier.deltat1 = deltat1;
carrier.deltab1 = deltab1;
carrier.deltat2 = deltat2;
carrier.deltab2 = deltab2;
carrier.Ti1 = Ti1;
carrier.Ti2 = Ti2;

carrier.deltatg1 = deltatg1;
carrier.deltabg1 = deltabg1;
carrier.deltatg2 = deltatg2;
carrier.deltabg2 = deltabg2;
carrier.genTi1 = genTi1;
carrier.genTi2 = genTi2;

carrier.Pref1 = Pref1;
carrier.deltaref1 = deltaref1;
carrier.Eref1 = Eref1;
carrier.Pref2 = Pref2;
carrier.deltaref2 = deltaref2;
carrier.Eref2 = Eref2;
carrier.Hr1 = Hr1;
carrier.Hr2 = Hr2;

carrier.t1_1 = t1_1;
carrier.t1_2 = t1_2;
carrier.t1_3 = t1_3;
carrier.mode1_1 = mode1_1;
carrier.mode1_2 = mode1_2;
carrier.mode1_3 = mode1_3;
carrier.t2_1 = t2_1;
carrier.t2_2 = t2_2;
carrier.t2_3 = t2_3;
carrier.mode2_1 = mode2_1;
carrier.mode2_2 = mode2_2;
carrier.mode2_3 = mode2_3;

statusoppd('Simulation started');
tic
set(objectfinder('simstatus'),'string','Running');
set(objectfinder('simstatus'),'backgroundcolor','yellow');
set(objectfinder('simstatus_percentage'),'backgroundcolor','yellow');
drawnow expose                                                  %Force gui update by flushing system event queue

results = DrivaSIMmk2(carrier);

set(objectfinder('simstatus'),'string','Complete');
set(objectfinder('simstatus'),'backgroundcolor','green');
set(objectfinder('simstatus_percentage'),'backgroundcolor','green');
statusoppd(['Simulation completed (',num2str(toc),' seconds)'])
end

%% PLOTTEFUNKSJON GUI
function [] = GUIplott(varargin)
    
    if ~exist('results')
        statusoppd('Finner ikke resultater. Avbryter plotting. Har du kjrt simuleringen?')
        return
    end
    cla(objectfinder('mainaxis'))
    
    plottype_string = get(objectfinder('plottype'),'string');
    plottype = strtrim(plottype_string(get(objectfinder('plottype'),'value'),:));

    ak = size(results.Q);
    pressuretransient = zeros(1,ak(3));
    flowtransient = pressuretransient;
    time = pressuretransient;
    
	if (strcmp(plottype,'Pressure Turbine') || strcmp(plottype,'Flow Turbine'))
        position = results.turbinepos;
    elseif strcmp(plottype,'Pressure Surge Chamber') ||strcmp(plottype,'Flow Surge Chamber')
        position =  results.surgepos;
    else
        position = results.turbinepos;
    end

    for i = 1:ak(3)
        pressuretransient(i) = results.H(1,position,i);
        if strcmp(plottype,'Flow Surge Chamber')
            flowtransient(i) = results.Q(1,position-1,i) - results.Q(1,position,i);
        else
            flowtransient(i) = results.Q(1,position,i);
        end
        time(i) = (i-1)*results.dt;
    end
    time = time(1:results.tmax/results.dt-1);
    pressuretransient = pressuretransient(1:length(time));
    flowtransient = flowtransient(1:length(time));
    results.surgeHeight = results.surgeHeight(1:length(time));
    
    time(end+1) = time(end) + results.dt;
    time(end+1) = time(end) + results.dt;
    
    if strcmp(plottype,'Pressure Turbine') || strcmp(plottype,'Pressure Surge Chamber')
        cla
        handle_save = objectfinder('mainaxis');
        if strcmp(plottype,'Pressure Surge Chamber')
            plot(objectfinder('mainaxis'),time(1:end-2),pressuretransient,'black','linewidth',2)
        else
            plot(objectfinder('mainaxis'),time,pressuretransient,'black','linewidth',2)
        end
        set(handle_save,'tag','mainaxis');
        if strcmp(plottype,'Pressure Turbine')
            title('Pressure at turbine')
        elseif strcmp(plottype,'Pressure Surge Chamber')
            title('Pressure at surge chamber')
        end
        xlabel('Time [s]')
        ylabel('Head [m]')
        grid on
        legend('Head')
        axis([0 time(end) 0.99*min(pressuretransient) 1.01*max(pressuretransient)])
    elseif strcmp(plottype,'Flow Turbine') || strcmp(plottype,'Flow Surge Chamber')
        cla
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),time,results.unit1_data.flow,'linewidth',2)
        set(handle_save,'tag','mainaxis');
        plot(objectfinder('mainaxis'),time,results.unit2_data.flow,'r','linewidth',2)
        set(handle_save,'tag','mainaxis');
        plot(objectfinder('mainaxis'),time,results.unit1_data.flow+results.unit2_data.flow,'black','linewidth',2)
        set(handle_save,'tag','mainaxis');
        if strcmp(plottype,'Flow Turbine')
            title('Flow at turbine')
        elseif strcmp(plottype,'Flow Surge Chamber')
            title('Flow at surge chamber')
        end
        xlabel('Time [s]')
        ylabel('Flow [m3/s]')
        grid on
        legend('Unit1','Unit2','Sum')
        %axis([0 time(end) -2 1.2*max(flowtransient)])
        axis auto
    elseif strcmp(plottype,'Surge level')
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),time,results.surgeHeight)
        set(handle_save,'tag','mainaxis');
        title('Water height in chamber')
        grid on
        xlabel('Time [s]')
        ylabel('Height [m]')
        legend('Surge Chamber water level')
        %axis([0 time(end) 0.99*min(results.surgeHeight) 1.01*max(results.surgeHeight)])
        axis auto
    elseif strcmp(plottype,'Turbine Rotation Speed')
        handle_save = objectfinder('mainaxis');
        omegarefline = zeros(length(results.unit1_data.turb_omega),1);
        omegarefline(:) = results.unit1_data.omegaref*(30/pi);
        deltaderived1 = zeros(1,length(results.unit1_data.turb_omega));
        deltaderived2 = deltaderived1;
        for i = 2:length(deltaderived1)
           deltaderived1(i) = results.unit1_data.gen_delta(i) - results.unit1_data.gen_delta(i-1);
           deltaderived2(i) = results.unit2_data.gen_delta(i) - results.unit2_data.gen_delta(i-1);
        end
        hold on
        plot(omegarefline,'--r')
        plot(objectfinder('mainaxis'),results.unit1_data.turb_omega(:)*(30/pi),'linewidth',2)
        plot(objectfinder('mainaxis'),results.unit2_data.turb_omega(:)*(30/pi),'red','linewidth',2)
        max(results.unit1_data.turb_omega(:))*(30/pi)
        min(results.unit1_data.turb_omega(:))*(30/pi)
%         plot(deltaderived1,'blue','linewidth',2)
%         plot(deltaderived2,'red','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Turbine Rotational Speed')
        grid on
        legend('Reference','Unit1 Omega','Unit2 Omega','Location','NorthWest');
        xlabel('Time [s]')
        ylabel('Rotational speed [rad/s]')
        if (max(results.unit1_data.turb_omega(:)) - min(results.unit1_data.turb_omega(:)) < 1e-4)
            axis([0 length(results.unit1_data.turb_omega(:)) omegarefline(1)-3 omegarefline(1)+3])
        else
            axis auto
        end
    elseif strcmp(plottype,'Kappa')
        hold on
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),results.unit1_data.kappa(:),'black','linewidth',2)
        set(handle_save,'tag','mainaxis');
        plot(objectfinder('mainaxis'),results.unit2_data.kappa(:),'blue','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Turbine Opening')
        grid on
        xlabel('Time [s]')
        ylabel('Guide vane opening [-]')
        legend('Unit1 Kappa','Unit2 Kappa')
        axis auto
    elseif strcmp(plottype,'Generator Magnetics')
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),results.unit1_data.gen_ko(:),'linewidth',2)
        set(handle_save,'tag','mainaxis');
        plot(objectfinder('mainaxis'),results.unit2_data.gen_ko(:),'red','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Generator magnetics')
        legend('Unit 1','Unit 2')
        grid on
        xlabel('Time [s]')
        ylabel('Flux constant [-]')
        %axis([1 time(end)+1 0.99*min(results.unit1_data.gen_ko(:)) 1.01*max(results.unit1_data.gen_ko(:))])
        axis auto
    elseif strcmp(plottype,'Generator Angle')
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),results.unit1_data.gen_delta(:),'linewidth',2)
        plot(objectfinder('mainaxis'),results.unit2_data.gen_delta(:),'red','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Rotor/Stator angle displacement')
        grid on
        legend('Unit 1','Unit 2')
        xlabel('Time [s]')
        ylabel('Angle [rad]')
        axis auto
    elseif strcmp(plottype,'Generator Voltage')
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),results.unit1_data.gen_voltage(:)/1000,'linewidth',2)
        plot(objectfinder('mainaxis'),results.unit2_data.gen_voltage(:)/1000,'red','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Generator voltage')
        legend('Unit 1','Unit 2')
        grid on
        xlabel('Time [s]')
        ylabel('Voltage [kV]')
        axis auto
    elseif strcmp(plottype,'Generator Current')
        handle_save = objectfinder('mainaxis');
        plot(objectfinder('mainaxis'),results.unit1_data.gen_current(:)/1000,'linewidth',2)
        plot(objectfinder('mainaxis'),results.unit2_data.gen_current(:)/1000,'red','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Generator Current')
        legend('Unit 1','Unit 2')
        grid on
        xlabel('Time [s]')
        ylabel('Current [kA]')
        axis auto
    elseif strcmp(plottype,'Power')
        handle_save = objectfinder('mainaxis');
        power1 = results.unit1_data.gen_voltage(:).*results.unit1_data.gen_current(:);
        power1 = power1/(10^6);
        power2 = results.unit2_data.gen_voltage(:).*results.unit2_data.gen_current(:);
        power2 = power2/(10^6);
        plot(objectfinder('mainaxis'),power1,'linewidth',2)
        plot(objectfinder('mainaxis'),power2,'red','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Generator Power')
        legend('Unit1','Unit2')
        grid on
        xlabel('Time [s]')
        ylabel('Power [MW]')
        axis auto
    elseif strcmp(plottype,'Turbine all')
        handle_save = objectfinder('mainaxis');
        hold on
        plot(objectfinder('mainaxis'),results.unit1_data.turb_omega(2:end)/results.unit1_data.omegaref,'linewidth',2)
        plot(objectfinder('mainaxis'),results.unit2_data.turb_omega(2:end)/results.unit2_data.omegaref,'black','linewidth',2)
        plot(objectfinder('mainaxis'),pressuretransient/results.unit1_data.Hr,'--red','linewidth',2)
        plot(objectfinder('mainaxis'),flowtransient/(results.unit1_data.Qr + results.unit2_data.Qr),'red','linewidth',2)
        plot(objectfinder('mainaxis'),results.unit1_data.kappa(:),'--black')
        plot(objectfinder('mainaxis'),results.unit2_data.kappa(:),'black')
        set(handle_save,'tag','mainaxis');
        title('Turbine data collective plot')
        xlabel('Time [s]')
        ylabel('Reduced variables')
        legend('Unit1 omega','Unit2 omega','Pressure','Total Flow','Unit1 Kappa','Unit2 Kappa')
        grid on
        axis auto
	elseif strcmp(plottype,'Stability')
        handle_save = objectfinder('mainaxis');
        power1 = results.unit1_data.gen_voltage(:).*results.unit1_data.gen_current(:);
        power1 = power1/(10^6);
        rpm = results.unit1_data.turb_omega;
        plot(objectfinder('mainaxis'),power1,rpm)
        set(handle_save,'tag','mainaxis');
        title('Turbine maneuvering')
        xlabel('Power [MW]')
        ylabel('RPM')
        grid on
        axis auto
	elseif strcmp(plottype,'Pressure Transient')
        for i = 1:ak(3)
            plot(objectfinder('mainaxis'),results.H(1,:,i))
            title('Pressure Transient Analysis')
            ylabel('Pressure [m]')
            xlabel('Conduit position')
            axis([0 ak(2) 450 max(max(results.H(1,:,:)))])
            M(i) = getframe;
            clc
            i*results.dt;
        end
    elseif strcmp(plottype,'Efficiency')
        handle_save = objectfinder('mainaxis');
        hold on
        plot(objectfinder('mainaxis'),results.unit1_data.eta,'linewidth',2)
        plot(objectfinder('mainaxis'),results.unit2_data.eta,'black','linewidth',2)
        set(handle_save,'tag','mainaxis');
        title('Unit efficiency')
        xlabel('Time')
        ylabel('Efficiency')
        grid on
        legend('Unit1','Unit2')
        axis auto
    end
end

%% PLOTTEFUNKSJON EKSTERN
function [] = externalplott(varargin)
    
    if ~exist('results')
        statusoppd('Finner ikke resultater. Avbryter plotting. Har du kjrt simuleringen?')
        return
    end
    
    plottype_string = get(objectfinder('plottype'),'string');
    plottype = strtrim(plottype_string(get(objectfinder('plottype'),'value'),:));
    
    ak = size(results.Q);
    pressuretransient = zeros(1,ak(3));
    flowtransient = pressuretransient;
    time = pressuretransient;
    
	if (strcmp(plottype,'Pressure Turbine') || strcmp(plottype,'Flow Turbine'))
        position = results.turbinepos;
    elseif strcmp(plottype,'Pressure Surge Chamber') ||strcmp(plottype,'Flow Surge Chamber')
        position =  results.surgepos;
    else
        position = results.turbinepos;
    end

    for i = 1:ak(3)
        pressuretransient(i) = results.H(1,position,i);
        if strcmp(plottype,'Flow Surge Chamber')
            flowtransient(i) = results.Q(1,position-1,i) - results.Q(1,position,i);
        else
            flowtransient(i) = results.Q(1,position,i);
        end
        time(i) = (i-1)*results.dt;
    end
    time = time(1:results.tmax/results.dt-1);
    pressuretransient = pressuretransient(1:length(time));
    flowtransient = flowtransient(1:length(time));
    results.surgeHeight = results.surgeHeight(1:length(time));
    
    time(end+1) = time(end) + results.dt;
    time(end+1) = time(end) + results.dt;
    
    if strcmp(plottype,'Pressure Turbine') || strcmp(plottype,'Pressure Surge Chamber')
        figure
        plot(time(1:end-2),pressuretransient,'black','linewidth',3)
        set(gca,'fontsize',14);
        if strcmp(plottype,'Pressure Turbine')
            title('Pressure at turbine inlet')
        elseif strcmp(plottype,'Pressure Surge Chamber')
            title('Pressure at surge chamber')
        end
        xlabel('Time [s]')
        ylabel('Head [m]')
        grid on
        legend('Head','location','northwest')
        axis([0 time(end) 0.99*min(pressuretransient) 1.01*max(pressuretransient)])
        %xlim([0 14])
        
    elseif strcmp(plottype,'Flow Turbine') || strcmp(plottype,'Flow Surge Chamber')
        figure
        %plot(time,flowtransient/(2*results.unit1_data.Qr))
        hold on
        plot(time(1:length(results.unit1_data.flow)),results.unit1_data.flow,'linewidth',3)
        plot(time(1:length(results.unit2_data.flow)),results.unit2_data.flow,'red','linewidth',3)
        if strcmp(plottype,'Flow Turbine')
            title('Flow at turbine')
            legend('Flow unit 1','Flow unit 2')
        elseif strcmp(plottype,'Flow Surge Chamber')
            title('Flow at surge chamber')
        end
        xlabel('Time [s]','fontsize',14)
        ylabel('Flow [m3/s]','fontsize',14)
        %xlim([0 14])
        ylim([0 20])
        grid on
        legend('Unit1','Unit2','location','southwest')
        set(gca,'fontsize',14);
        %axis([0 time(end) -2 1.2*max(flowtransient)])
    elseif strcmp(plottype,'Surge level')
        figure
        plot(time(1:end-2),results.surgeHeight,'linewidth',3)
        title('Water height in chamber')
        grid on
        xlabel('Time [s]','fontsize',14)
        ylabel('Height [m]','fontsize',14)
        set(gca,'fontsize',14);
        legend('Surge Chamber water level','location','northwest')
        xlim([0 35])
        %axis([0 time(end) 0.99*min(results.surgeHeight) 1.01*max(results.surgeHeight)])
        axis auto
    elseif strcmp(plottype,'Turbine Rotation Speed')
        fighandle = figure;
        %hold on
        omegarefline = zeros(length(results.unit1_data.turb_omega),1);
        omegarefline(:) = results.unit1_data.omegaref*(30/pi);
        %plot(time,omegarefline,'--r')
        %set(gca,'yscale','log');
        
        [AX,h1,h2] = plotyy(time(1:length(results.unit2_data.turb_omega(:))),results.unit2_data.turb_omega(:)*(30/pi),time(1:length(results.unit2_data.turb_omega(:))),results.unit1_data.turb_omega(:)*(30/pi));
        hold on
        ylabel(AX(1),'Rotational speed');
        ylabel(AX(2),'Rotational speed');
        %set(AX(1),'fontsize',30);
%         axes(AX(1))
%         h3 = line(time,results.unit1_data.kappa(:));
%         axes(AX(1))
%         h4 = line(time,results.unit2_data.kappa(:));
%         axes(AX(2))
%         
%         %[AX,h1,h2] = plotyy(time,results.unit1_data.turb_omega(:)*(30/pi)/600,time,results.unit2_data.turb_omega(:)*(30/pi)/600);
%         %[AX,h1,h2] = plotyy(time,results.unit2_data.turb_omega(:)*(30/pi)/600,time,results.unit1_data.turb_omega(:)*(30/pi)/600);
%         %[AX,h1,h2] = plotyy(time,results.unit2_data.kappa(:),time,results.unit1_data.kappa(:));
%         set(AX,'yscale','linear');
         set(h1,'color','black');
         set(h2,'color','blue');
%         set(h3,'color','green');
%         set(h4,'color','black');
%         set(h4,'linestyle','--');
         set([h1 h2],'linewidth',3)
         set(AX(1),'fontsize',16);
         set(AX(2),'fontsize',16);
         set(gca,'fontsize',16);
         set(AX(1),'Ycolor','black');
         set(AX(2),'Ycolor','blue');
%         %plot(time,results.unit1_data.turb_omega(:)*(30/pi),'linewidth',2)
%         %plot(time,results.unit2_data.turb_omega(:)*(30/pi),'red','linewidth',2)
        title('Turbine Rotational Speed')
        grid on
        legend('Unit 1','Unit 2','Location','NorthWest');
        xlabel('Time [s]')
        ylabel('Rotational speed [rad/s]')
        set(fighandle,'position',[159 405 1.3*560 1.3*420])
        if (max(results.unit1_data.turb_omega(:)) - min(results.unit1_data.turb_omega(:)) < 1e-4)
            axis([0 length(results.unit1_data.turb_omega(:)) omegarefline(1)-3 omegarefline(1)+3])
        else
            axis auto
        end
    elseif strcmp(plottype,'Kappa')
        figure
        hold on
        %plot(time,results.unit1_data.kappa(:),'black','linewidth',2)
        %plot(time,results.unit2_data.kappa(:),'blue','linewidth',2)
        [AX,h1,h2] = plotyy(time(1:length(results.unit2_data.kappa(:))),results.unit2_data.kappa(:),time(1:length(results.unit1_data.kappa(:))),results.unit1_data.kappa(:));
        set(h2,'color','blue');
        set(h1,'color','black')
        set([h1 h2],'linewidth',3)
        set(AX,'fontsize',14);
        set(AX(1),'Ycolor','black');
        set(AX(2),'Ycolor','blue');
        set(AX(1),'ytickMode','auto');
        set(AX(2),'ytickMode','auto');
        title('Turbine Opening')
        grid on
        xlabel('Time [s]')
        ylabel('Guide vane opening [-]')
        legend('Unit1','Unit2','location','southeast')
    elseif strcmp(plottype,'Generator Magnetics')
        figure
        hold on
        plot(time(1:length(results.unit1_data.gen_ko(:))),results.unit1_data.gen_ko(:),'linewidth',3)
        plot(time(1:length(results.unit2_data.gen_ko(:))),results.unit2_data.gen_ko(:),'red','linewidth',3)
        title('Generator magnetics','fontsize',14)
        legend('Unit 1','Unit 2','fontsize',14)
        grid on
        xlabel('Time [s]','fontsize',14)
        ylabel('Flux constant [-]','fontsize',14)
        set(gca,'fontsize',14)
        %axis([1 time(end)+1 0.99*min(results.unit1_data.gen_ko(:)) 1.01*max(results.unit1_data.gen_ko(:))])
        axis auto
    elseif strcmp(plottype,'Generator Angle')
        figure
        hold on
        plot(time(1:length(results.unit1_data.gen_delta(:))),results.unit1_data.gen_delta(:),'linewidth',3)
        plot(time(1:length(results.unit2_data.gen_delta(:))),results.unit2_data.gen_delta(:),'red','linewidth',3)
        title('Rotor/Stator angle displacement','fontsize',15)
        grid on
        legend('Unit 1','Unit 2','fontsize',15)
        xlabel('Time [s]','fontsize',15)
        ylabel('Angle [rad]','fontsize',15)
        set(gca,'fontsize',15);
        xlim([0 35])
        axis auto
    elseif strcmp(plottype,'Generator Voltage')
        figure
        hold on
        plot(time(1:length(results.unit1_data.gen_voltage(:)/1000)),results.unit1_data.gen_voltage(:)/1000,'linewidth',2)
        plot(time(1:length(results.unit2_data.gen_voltage(:)/1000)),results.unit2_data.gen_voltage(:)/1000,'red','linewidth',2)
        title('Generator voltage')
        legend('Unit 1','Unit 2')
        grid on
        xlabel('Time [s]')
        ylabel('Voltage [kV]')
        axis auto
    elseif strcmp(plottype,'Generator Current')
        figure
        hold on
        plot(time(1:length(results.unit1_data.gen_current(:))),results.unit1_data.gen_current(:)/1000,'linewidth',2)
        plot(time(1:length(results.unit1_data.gen_current(:))),results.unit2_data.gen_current(:)/1000,'red','linewidth',2)
        title('Generator Current')
        legend('Unit 1','Unit 2')
        grid on
        xlabel('Time [s]')
        ylabel('Current [kA]')
        axis auto
    elseif strcmp(plottype,'Power')
        elpower1 = results.unit1_data.gen_voltage(:).*results.unit1_data.gen_current(:);
        elpower1 = elpower1/(10^6);
        elpower2 = results.unit2_data.gen_voltage(:).*results.unit2_data.gen_current(:);
        elpower2 = elpower2/(10^6);
        
        figure
        hold on
        %plot(time(1:length(results.unit1_data.power)),results.unit1_data.power*0.982,'linewidth',2)
        %plot(time(1:length(results.unit2_data.power)),results.unit2_data.power*0.982,'red','linewidth',2)
        plot(time(1:length(elpower1)),elpower1,'linewidth',3)
        plot(time(1:length(elpower2)),elpower2,'red','linewidth',3)
        title('Generator Power','fontsize',14)
        grid on
        xlabel('Time [s]','fontsize',14)
        ylabel('Power [MW]','fontsize',14)
        set(gca,'fontsize',14)
        legend('Unit 1','Unit 2')
        axis auto
    elseif strcmp(plottype,'Turbine all')
        fighandle = figure;
        hold on
        plot(time(1:length(results.unit1_data.turb_omega)),results.unit1_data.turb_omega/results.unit1_data.omegaref,'linewidth',3);
        plot(time(1:length(results.unit2_data.turb_omega)),results.unit2_data.turb_omega/results.unit2_data.omegaref,'black','linewidth',3)
        plot(time(1:length(pressuretransient)),pressuretransient/results.unit1_data.Hr,'--red','linewidth',2)
        plot(time(1:length(pressuretransient)),flowtransient/(results.unit1_data.Qr + results.unit2_data.Qr),'red','linewidth',3)
        plot(time(1:length(results.unit1_data.kappa)),results.unit1_data.kappa(:),'--blue','linewidth',3)
        plot(time(1:length(results.unit2_data.kappa)),results.unit2_data.kappa(:),'--black','linewidth',3)
        title('Turbine data collective plot','fontsize',15)
        xlabel('Time [s]','fontsize',15)
        ylabel('Reduced variables','fontsize',15)
        legend('Unit1 omega','Unit2 omega','Pressure','Total Flow','Unit1 Kappa','Unit2 Kappa','location','southwest')
        grid on
        axis auto
        set(gca,'fontsize',15);
        xlim([1 35])
        set(fighandle,'position',[159 405 1.3*560 1.3*420])
    elseif strcmp(plottype,'Stability')
        
        power1 = results.unit1_data.gen_voltage(:).*results.unit1_data.gen_current(:);
        power1 = power1/(10^6);
        power2 = results.unit2_data.gen_voltage(:).*results.unit2_data.gen_current(:);
        power2 = power2/(10^6);
        
        figure
        grid on
        rpm1 = results.unit1_data.turb_omega*30/pi/12;
        plot(results.unit1_data.power(1:end)/1e6,rpm1(1:end),'linewidth',3)
        %plot3(power1,rpm1(1:end),time,'linewidth',3)
        %plot(power1,rpm1(1:end),'linewidth',3)
        set(gca,'fontsize',14);
        title('Stability plot')
        xlabel('Turbine output [MW]')
        grid on
        ylabel('Grid frequency [Hz]');
        legend('Unit 1','Unit 2')
        
        
        %figure
        %grid on
        hold on
        %rpm1 = results.unit1_data.turb_omega*30/pi;
        rpm2 = results.unit2_data.turb_omega*30/pi/12;
        plot(results.unit2_data.power(1:end)/1e6,rpm2(1:end),'linewidth',3,'color','black')
        %plot(power2,rpm2,'linewidth',3,'color','black')
        set(gca,'fontsize',14);
        title('Stability plot')
        xlabel('Turbine output [MW]')
        ylabel('Grid frequency [Hz]');
        grid on
        %ylim([599.5 602])
        legend('Unit1','Unit 2')
    elseif strcmp(plottype,'Pressure Transient')
        figure
        for i = 1:ak(3)
            plot(results.H(1,:,i))
            title('Pressure Transient Analysis')
            ylabel('Pressure [m]')
            xlabel('Conduit position')
            axis([0 ak(2) 450 max(max(results.H(1,:,:)))])
            M(i) = getframe;
            clc
            i*results.dt
        end
	elseif strcmp(plottype,'Efficiency')
        figure
        hold on
        plot(time(1:length(results.unit1_data.eta)),results.unit1_data.eta,'linewidth',3)
        plot(time(1:length(results.unit2_data.eta)),results.unit2_data.eta,'black','linewidth',3)
        title('Unit efficiency','fontsize',14)
        xlabel('Time','fontsize',14)
        ylabel('Efficiency','fontsize',14)
        ylim([0.92 0.96])
        grid on
        legend('Unit1','Unit2','fontsize',14)
        set(gca,'fontsize',14)
        axis auto
    end
end

%% IMPLEMENTASJON AV NEDSTENGNINGSRUTINE
%Funksjonen kalles nr brukeren prver  lukke vinduet. Brukeren blir spurt om bekreftelse p dette. Dersom brukeren bekrefter blir guiet
%lukket, et kall til funksjonen som skriver deler av PROGDATA til fil blir kalt, deretter blir structene S og PROGDATA slettet.
function lukk(varargin)
    
selection = questdlg('nsker du  lukke programmet?',...                        %Oppretter en dialogboks med flgende query
                     'Bekreftelse p lukking',...
                     'Ja','Nei','Ja');                                          %Valg og default-valg
switch selection,
   case 'Ja',                                                                   %Dersom brukeren svarer ja
       clear S;                                                                 %sletter S
       clear results ;                                                          %sletter resultater
    delete(gcf)                                                                 %Slett figuren(gui). Dette resulterer i lukking
   case 'Nei'                                                                   %Dersom brukeren svarer nei
     return;                                                                    %lukk dialogboks og fortsett
end
end


% %Funksjon som oppdaterer statusvindu for visning til bruker. Funksjonen returnerer en kopi av hele statusstr.  Funskjonen mottar structene
% %PROGDATA og S, string som inneholder melding som skal skrives, samt en verdi som settes inn i strengen ved hjelp av sprintf om nskelig (0
% %dersom dette ikke er nskelig)
 function [] = statusoppd(mld)              

    mld = strcat(datestr(now),': ',mld);                                     

	handle = objectfinder('statusw');
    oldstr = get(handle,'string');
    
    if isempty(oldstr)
        set(handle,'string',mld)
        return
    elseif ~iscell(oldstr)
        tempcell = cell(2,1);
        tempcell{1,1} = mld;
        tempcell{2,1} = oldstr;
    else
        tempcell = cell(1,length(oldstr)+1);                            %oppretter midlertidig celle for konstruksjon av ny holder for info
        for i = 1:length(oldstr)
            tempcell{i+1} = oldstr{i};                                  %Plasserer inn gamle meldinger og lar det vre en ledig frst for ferskeste streng
        end
        tempcell{1} = mld;         
    end
    set(handle,'string',tempcell);
 end
end